<script setup>
import { Link, useForm } from "@inertiajs/vue3";
import DestroyLink from "@/Components/DestroyLink.vue";
import EditLink from "@/Components/EditLink.vue";
import ShowLink from "@/Components/ShowLink.vue";
import { ref } from "vue";

const all = ref(false);

const props = defineProps({
    items: Object,
    routes: Object,
});

const form = useForm({
    checkbox: false,
    ids: [],
});

const deleteAuthors = () => {
    form.delete(route("authors.destroy-many"), {
        onSuccess: () => form.reset(),
    });
};

const selectAll = () => {
    form.ids = all.value ? props.items.data.map((item) => item.id) : [];
};
</script>

<template>
    <div v-if="form.ids.length > 1" class="p-4 bg-white">
        <form class="" @submit.prevent="deleteAuthors">
            <button
                class="inline-flex items-center px-4 py-2 h-8.5 bg-red-500 dark:bg-red-200 border border-transparent rounded-md font-semibold text-xs text-white dark:text-red-500 uppercase tracking-widest hover:bg-red-700 dark:hover:bg-white focus:bg-red-700 dark:focus:bg-white active:bg-red-900 dark:active:bg-red-300 focus:outline-none focus:ring-2 focus:ring-red-500 focus:ring-offset-2 dark:focus:ring-offset-red-800 transition ease-in-out duration-150"
            >
                Delete {{ form.ids.length }} items
            </button>
        </form>
    </div>
    <table
        class="p-4 w-full text-sm text-left rtl:text-right text-gray-500 dark:text-gray-400"
    >
        <thead
            class="text-xs text-gray-700 uppercase bg-gray-50 dark:bg-gray-700 dark:text-gray-400"
        >
            <tr>
                <th class="p-4" scope="col">
                    <div class="flex items-center">
                        <input
                            class="rounded dark:bg-gray-900 border-gray-300 dark:border-gray-700 text-indigo-600 shadow-sm focus:ring-indigo-500 dark:focus:ring-indigo-600 dark:focus:ring-offset-gray-800"
                            type="checkbox"
                            id="checkbox"
                            v-model="all"
                            @change="selectAll"
                        />
                        <label for="checkbox" class="sr-only">checkbox</label>
                    </div>
                </th>
                <th class="px-6 py-3" scope="col">
                    {{ items.titles.name }}
                </th>
                <th class="px-6 py-3" scope="col">
                    {{ items.titles.biography }}
                </th>
                <th class="px-6 py-3" scope="col">
                    {{ items.titles.actions_title }}
                </th>
            </tr>
        </thead>
        <tbody>
            <tr
                v-for="item in items.data"
                class="bg-white border-b dark:bg-gray-800 dark:border-gray-700 hover:bg-gray-50 dark:hover:bg-gray-600"
            >
                <td class="w-4 p-4">
                    <div class="flex items-center">
                        <input
                            :id="item.id"
                            v-model="form.ids"
                            :value="item.id"
                            class="rounded dark:bg-gray-900 border-gray-300 dark:border-gray-700 text-indigo-600 shadow-sm focus:ring-indigo-500 dark:focus:ring-indigo-600 dark:focus:ring-offset-gray-800"
                            type="checkbox"
                            :checked="form.ids.includes(item.id)"
                        />
                        <label :for="item.id" class="sr-only">checkbox</label>
                    </div>
                </td>
                <th
                    class="px-6 py-4 font-medium text-gray-900 whitespace-nowrap dark:text-white"
                    scope="row"
                >
                    {{ item.name }}
                </th>
                <th
                    class="px-6 py-4 font-medium text-gray-900 whitespace-nowrap dark:text-white"
                    scope="row"
                >
                    {{ item.biography }}
                </th>
                <td class="px-6 py-4 flex">
                    <ShowLink :href="route(props.routes.show, item.id)" />
                    <EditLink
                        class="mr-3"
                        :href="route(props.routes.edit, item.id)"
                    />
                    <DestroyLink
                        :href="route(props.routes.destroy, item.id)"
                        :icon="true"
                    />
                </td>
            </tr>
        </tbody>
    </table>
</template>
